<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link rel="stylesheet" href="game-styles.css" />
    <script type="text/javascript" src="game.js"></script>
    <title>Game Page</title>
    <script>
      let game;
      let message;
      window.onload = () => {
        const player1 = localStorage.getItem("player1");
        const player2 = localStorage.getItem("player2");
        game = new Game(player1, player2);
        message = game.start();
        createGrid();
      };
      const robotRandomColumn = () => {
        return 1 + Math.floor(Math.random() * 7);
      };
      const clickHandler = (tokenId, columnNumber) => {
        const playerSymbol = game.moveNumber % 2 === 0 ? "red" : "yellow";

        game.move(columnNumber);
        message = game.display();
        refreshGridDisplay(columnNumber);
        if (game.name2 === "Robbie the Robot") {
          const randomColumn = robotRandomColumn();
          game.move(randomColumn);
          message = game.display();
          refreshGridDisplay(randomColumn);
        }
      };
      const refreshGridDisplay = (columnNumber) => {
        game.grid.forEach((gridRow, index) => {
          const dropToken = (colour) => {
            const token = document.getElementById(
              `game:grid:row${Math.abs(index - 6)}:col${columnNumber}`
            );
            token.classList.add(`${colour}`, "token", "token-start");
            setTimeout(() => {
              token.classList.remove("empty");
              token.classList.add("token-end");
            }, 10);
          };
          if (gridRow[columnNumber - 1] === "X") {
            dropToken("red");
          }
          if (gridRow[columnNumber - 1] === "Y") {
            dropToken("yellow");
          }
        });
      };
      const createGrid = () => {
        const container = document.querySelector(
          '[data-testid="game-container"]'
        );
        const gridArray = [
          [6, 1],
          [6, 2],
          [6, 3],
          [6, 4],
          [6, 5],
          [6, 6],
          [6, 7],
          [5, 1],
          [5, 2],
          [5, 3],
          [5, 4],
          [5, 5],
          [5, 6],
          [5, 7],
          [4, 1],
          [4, 2],
          [4, 3],
          [4, 4],
          [4, 5],
          [4, 6],
          [4, 7],
          [3, 1],
          [3, 2],
          [3, 3],
          [3, 4],
          [3, 5],
          [3, 6],
          [3, 7],
          [2, 1],
          [2, 2],
          [2, 3],
          [2, 4],
          [2, 5],
          [2, 6],
          [2, 7],
          [1, 1],
          [1, 2],
          [1, 3],
          [1, 4],
          [1, 5],
          [1, 6],
          [1, 7],
        ];
        gridArray.forEach((element) => {
          const gridItem = document.createElement("div");
          gridItem.classList.add("tokenContainer");
          gridId = `game:grid:row${element[0]}:col${element[1]}`;
          gridItem.setAttribute("data-testid", `${gridId}`);
          gridItem.setAttribute(
            "onclick",
            `clickHandler('${gridId}', ${element[1]})`
          );
          container.appendChild(gridItem);

          const emptySlot = document.createElement("div");
          emptySlot.classList.add("token");
          emptySlot.classList.add("empty");
          gridItem.appendChild(emptySlot);

          const token = document.createElement("div");
          token.id = `game:grid:row${element[0]}:col${element[1]}`;
          token.setAttribute("data-testid", `token-${gridId}`);
          gridItem.appendChild(token);
        });
      };
    </script>
  </head>
  <body>
    <h1 data-testid="game-name-player1" id="nameheading1"></h1>
    <h1 data-testid="game-name-player2" id="nameheading2"></h1>
    <h2 data-testid="game-message" id="game-message"></h2>
    <script>
      document.getElementById("nameheading1").innerText =
        window.localStorage.getItem("player1");
    </script>
    <script>
      document.getElementById("nameheading2").innerText =
        window.localStorage.getItem("player2");
    </script>
    <script>
      setInterval(() => {
        document.getElementById("game-message").innerText = message;
      }, 100);
    </script>
    <div data-testid="page-container" class="page-container">
      <div class="grid-item"></div>
      <div class="grid-item"></div>
      <div class="grid-item"></div>
      <div class="grid-item"></div>
      <div data-testid="game-container" class="game-container"></div>
      <div class="grid-item"></div>
      <div class="grid-item"></div>
      <div class="grid-item"></div>
      <div class="grid-item"></div>
    </div>
  </body>
</html>
